Results:
Loading...

JavaScript Data GridGet Started with AG Grid

Quick Look Code Example
const columnDefs = [
  { field: "make" },
  { field: "model" },
  { field: "price" }
];

// specify the data
const rowData = [
  { make: "Toyota", model: "Celica", price: 35000 },
  { make: "Ford", model: "Mondeo", price: 32000 },
  { make: "Porsche", model: "Boxster", price: 72000 }
];

// let the grid know which columns and what data to use
const gridOptions = {
  columnDefs: columnDefs,
  rowData: rowData
};

// setup the grid after the page has finished loading
document.addEventListener('DOMContentLoaded', () => {
    const gridDiv = document.querySelector('#myGrid');
    new agGrid.Grid(gridDiv, gridOptions);
});
<!DOCTYPE html>
<html lang="en">
<head>
    <title>Ag-Grid Basic Example</title>
    <script src="https://cdn.jsdelivr.net/npm/ag-grid-community/dist/ag-grid-community.min.js"></script>
    <script src="main.js"></script>
</head>
<body>
    <div id="myGrid" style="height: 200px; width:500px;" class="ag-theme-alpine"></div>
</body>
</html>

Getting Started with Community Video

In this video we detail the steps to get an application working with AG Grid Community. We show how to set up Rows and Columns, set some Grid Properties, use the Grid's API and listen to Grid events.



Getting Started with Enterprise Video

The video then follows showing how to get started with AG Grid Enterprise. Please take a look at Enterprise, you don't need a license to trial AG Grid Enterprise, you only need to get in touch if you decide to use it in your project.




Getting Started with AG Grid Community

Below we provide code for a simple AG Grid application. To get this working locally, create a new application with one index.html page and have it served from a local web server. If you are not able to set up a web server, then you can start with a new JS project from Plunker.


Copy in Application Code

Copy the content below into the file index.html:

<!DOCTYPE html>
<html lang="en">
 <head>
   <meta charset="UTF-8" />
   <meta http-equiv="X-UA-Compatible" content="IE=edge" />
   <meta
     name="viewport"
     content="width=device-width, initial-scale=1.0"
   />
   <title>Ag Grid App</title>
   <!-- Include the JS for AG Grid -->
   <script src="https://cdn.jsdelivr.net/npm/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
   <!-- Include the core CSS, this is needed by the grid -->
   <link rel="stylesheet"
     href="https://cdn.jsdelivr.net/npm/ag-grid-community/styles/ag-grid.css"/>
   <!-- Include the theme CSS, only need to import the theme you are going to use -->
   <link rel="stylesheet"
     href="https://cdn.jsdelivr.net/npm/ag-grid-community/styles/ag-theme-alpine.css"/>
 </head>
 <body>
   <!-- Button to demonstrate calling the grid's API. -->
   <button onclick="deselect()">Deselect Rows</button>
   <!-- The div that will host the grid. ag-theme-alpine is the theme. -->
   <!-- The gid will be the size that this element is given. -->
   <div id="myGrid" class="ag-theme-alpine" style="height: 500px"></div>
   <script type="text/javascript">
       // Function to demonstrate calling grid's API
       function deselect(){
           gridOptions.api.deselectAll()
       }

       // Grid Options are properties passed to the grid
       const gridOptions = {

         // each entry here represents one column
         columnDefs: [
           { field: "make" },
           { field: "model" },
           { field: "price" },
         ],

         // default col def properties get applied to all columns
         defaultColDef: {sortable: true, filter: true},

         rowSelection: 'multiple', // allow rows to be selected
         animateRows: true, // have rows animate to new positions when sorted

         // example event handler
         onCellClicked: params => {
           console.log('cell was clicked', params)
         }
       };

       // get div to host the grid
       const eGridDiv = document.getElementById("myGrid");
       // new grid instance, passing in the hosting DIV and Grid Options
       new agGrid.Grid(eGridDiv, gridOptions);

       // Fetch data from server
       fetch("https://www.ag-grid.com/example-assets/row-data.json")
       .then(response => response.json())
       .then(data => {
         // load fetched data into grid
         gridOptions.api.setRowData(data);
       });
   </script>
 </body>
</html>
If everything is correct, you should see a simple grid that looks like this:

AG Grid in its simplest form

We will now break this file down and explain the different parts...


Importing JS & CSS, Setting Theme & Style

You can import all JS and CSS with ag-grid-community.min.js, or you can be selective and import just the JS ag-grid-community.min.noStyle.js and selectively include the CSS, so you don't download themes you don't want to use.

   <!-- Include the JS for AG Grid -->
   <script src="https://cdn.jsdelivr.net/npm/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
   <!-- Include the core CSS, this is needed by the grid -->
   <link rel="stylesheet"
     href="https://cdn.jsdelivr.net/npm/ag-grid-community/styles/ag-grid.css"/>
   <!-- Include the theme CSS, only need to import the theme you are going to use -->
   <link rel="stylesheet"
     href="https://cdn.jsdelivr.net/npm/ag-grid-community/styles/ag-theme-alpine.css"/>

OR

   <!-- Include the JS and CSS (all themes) for AG Grid. Larger download than needed -->
   <!-- as will includes themes you don't use -->
   <script src="https://cdn.jsdelivr.net/npm/ag-grid-community/dist/ag-grid-community.min.js"></script>

You can select from any of the Grid Provided Themes. If you don't like the provided themes you can Customise the Provided Theme or do not use a Theme and style the grid yourself from scratch.

The dimension of the Grid is also set on the parent DIV via style="height: 500px".

<div id="myGrid" class="ag-theme-alpine" style="height: 500px"></div>

Grid Options

Options are provided to the grid using a Grid Options object.

// Grid Options are properties passed to the grid
const gridOptions = {

  // each entry here represents one column
  columnDefs: [
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ],

  // default col def properties get applied to all columns
  defaultColDef: {sortable: true, filter: true},

  rowSelection: 'multiple', // allow rows to be selected
  animateRows: true, // have rows animate to new positions when sorted

  // example event handler
  onCellClicked: params => {
    console.log('cell was clicked', params)
  }
};

Creating New Grid Instance

The grid instance is created using new agGrid.Grid() passing in the DOM element to host the grid and the Grid Options.

// get div to host the grid
const eGridDiv = document.getElementById("myGrid");
// new grid instance, passing in the hosting DIV and Grid Options
new agGrid.Grid(eGridDiv, gridOptions);

Setting Row Data

Data is loaded from the server and set using the grid API setRowData().

// Fetch data from server
fetch("https://www.ag-grid.com/example-assets/row-data.json")
  .then(response => response.json())
  .then(data => {
     // load fetched data into grid
     gridOptions.api.setRowData(data);
  });

Accessing Grid's API

Once created, the grid places an API object on the Grid Options. This can then be accessed to use the grid's API.

// Function to demonstrate calling grid's API
function deselect(){
    gridOptions.api.deselectAll()
}

Consuming Grid Events

Listen to Grid Events by adding a callback to the appropriate on[eventName] onto the Grid Options. This example demonstrates consuming the cellClicked event.

const gridOptions = {
  onCellClicked: params => { // example event handler
    console.log('cell was clicked', params)
  }
  ....

Getting Started with AG Grid Enterprise

We would love for you to try out AG Grid Enterprise. There is no cost to trial. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.

To use AG Grid Enterprise instead of AG Grid Community, use the imports ag-grid-enterprise.min.noStyle.js and ag-grid-enterprise.min.js instead of ag-grid-community.min.noStyle.js and ag-grid-community.min.js.

For example if you were using ag-grid-community.min.js then make the follow change to enable all the Enterprise features.

- <script src="https://cdn.jsdelivr.net/npm/ag-grid-community@29.3.5/dist/ag-grid-community.min.js"></script>+ <script src="https://cdn.jsdelivr.net/npm/ag-grid-enterprise@29.3.5/dist/ag-grid-enterprise.min.js"></script>

And that is all, you create the grid the same way, except this time it comes installed with all the Enterprise features.

For example, you can now Row Group (an Enterprise Feature) by a particular Column by setting rowGroup=true on the Column Definition.

const gridOptions = {
  columnDefs: [
    { field: "make", rowGroup: true },
    { field: "model" },
    { field: "price" },
  ],
  ...

Results:
Loading...

React Data GridGet Started with AG Grid

Quick Look Code Example
import React, { useState } from 'react';
import { createRoot } from 'react-dom/client';
import { AgGridReact } from 'ag-grid-react';

import 'ag-grid-community/styles/ag-grid.css';
import 'ag-grid-community/styles/ag-theme-alpine.css';

const App = () => {
   const [rowData] = useState([
       {make: "Toyota", model: "Celica", price: 35000},
       {make: "Ford", model: "Mondeo", price: 32000},
       {make: "Porsche", model: "Boxster", price: 72000}
   ]);
   
   const [columnDefs] = useState([
       { field: 'make' },
       { field: 'model' },
       { field: 'price' }
   ])

   return (
       <div className="ag-theme-alpine" style={{height: 400, width: 600}}>
           <AgGridReact
               rowData={rowData}
               columnDefs={columnDefs}>
           </AgGridReact>
       </div>
   );
};

const root = createRoot(document.getElementById('root'));
root.render(<GridExample />);
<div id="root"></div>

Please refer to our Compatibility Chart for Supported Versions of React & AG Grid.

Getting Started with Community Video

In this video we detail the steps to get an application working with React and AG Grid Community. We show how to set up Rows and Columns, set some Grid Properties, use the Grid's API and listen to Grid events.



Getting Started with Enterprise Video

The video then follows showing how to get started with AG Grid Enterprise. Please take a look at Enterprise, you don't need a license to trial AG Grid Enterprise, you only need to get in touch if you decide to use it in your project.




Getting Started with AG Grid Community

Below we provide code for a simple AG Grid React application. To get this working locally, create a new React application as follows:

npx create-react-app hello
cd hello
npm install --save ag-grid-community
npm install --save ag-grid-react
npm start

If everything goes well, npm start has started the web server and conveniently opened a browser pointing to localhost:3000.


Grid Dependencies

Note the package.json has the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-react": "29.3.5",
   ...

ag-grid-community is the core logic of the Grid, and ag-grid-react is the React Rendering Engine. Both are needed for the grid to work with React and their versions must match.


Copy in Application Code

Copy the content below into the file App.js:

import React, { useState, useRef, useEffect, useMemo, useCallback} from 'react';
import { createRoot } from 'react-dom/client';
import { AgGridReact } from 'ag-grid-react'; // the AG Grid React Component

import 'ag-grid-community/styles/ag-grid.css'; // Core grid CSS, always needed
import 'ag-grid-community/styles/ag-theme-alpine.css'; // Optional theme CSS

const App = () => {

 const gridRef = useRef(); // Optional - for accessing Grid's API
 const [rowData, setRowData] = useState(); // Set rowData to Array of Objects, one Object per Row

 // Each Column Definition results in one Column.
 const [columnDefs, setColumnDefs] = useState([
   {field: 'make', filter: true},
   {field: 'model', filter: true},
   {field: 'price'}
 ]);

 // DefaultColDef sets props common to all Columns
 const defaultColDef = useMemo( ()=> ({
     sortable: true
   }));

 // Example of consuming Grid Event
 const cellClickedListener = useCallback( event => {
   console.log('cellClicked', event);
 }, []);

 // Example load data from server
 useEffect(() => {
   fetch('https://www.ag-grid.com/example-assets/row-data.json')
   .then(result => result.json())
   .then(rowData => setRowData(rowData))
 }, []);

 // Example using Grid's API
 const buttonListener = useCallback( e => {
   gridRef.current.api.deselectAll();
 }, []);

 return (
   <div>

     {/* Example using Grid's API */}
     <button onClick={buttonListener}>Push Me</button>

     {/* On div wrapping Grid a) specify theme CSS Class Class and b) sets Grid size */}
     <div className="ag-theme-alpine" style={{width: 500, height: 500}}>

       <AgGridReact ref={gridRef} // Ref for accessing Grid's API rowData={rowData} // Row Data for Rows columnDefs={columnDefs} // Column Defs for Columns defaultColDef={defaultColDef} // Default Column Properties animateRows={true} // Optional - set to 'true' to have rows animate when sorted
           rowSelection='multiple' // Options - allows click selection of rows onCellClicked={cellClickedListener} // Optional - registering for Grid Event /></div>
   </div>
 );
};

export default App;
If everything is correct, you should see a simple grid that looks like this:

AG Grid in its simplest form

We will now break this file down and explain the different parts...


Grid CSS and Themes

Two CSS files were loaded as follows:

import 'ag-grid-community/styles/ag-grid.css'; // Core grid CSS, always needed
import 'ag-grid-community/styles/ag-theme-alpine.css'; // Optional theme CSS

The first ag-grid.css is always needed. It's the core structural CSS needed by the grid. Without this, the Grid will not work.

The second ag-theme-alpine.css is the chosen Grid Theme. This is then subsequently applied to the Grid by including the Theme's CSS Class in the Grid's parent DIV className="ag-theme-alpine".

<div className="ag-theme-alpine" style={{width: 500, height: 500}}>

You can select from any of the Grid Provided Themes. If you don't like the provided themes you can Customise the Provided Theme or do not use a Theme and style the grid yourself from scratch.

The dimension of the Grid is also set on the parent DIV via style={{width: 500, height: 500}}. The grid will fill 100% in both directions, so size it's parent element to the required dimensions.


Setting Row Data

The Grid is provided Row Data via the rowData Grid Property. This is wired up using React useState() hook and loading the data from the server.

const [rowData, setRowData] = useState(); // Set rowData to Array of Objects, one Object per Row

...

// Example load data from server
useEffect(() => {
   fetch('https://www.ag-grid.com/example-assets/row-data.json')
   .then(result => result.json())
   .then(rowData => setRowData(rowData))
}, []);

...

<AgGridReact
   rowData={rowData} // Row Data for Rows
   ...
   />

Setting Column Definitions

Columns are defined by setting Column definitions. Each Column Definition defines one Column. Properties can be set for all Columns using the Default Column Definition.

// Each Column Definition results in one Column.
const [columnDefs, setColumnDefs] = useState([
   {field: 'make', filter: true},
   {field: 'model', filter: true},
   {field: 'price'}
]);

// DefaultColDef sets props common to all Columns
const defaultColDef = useMemo( ()=> ({
   sortable: true
}));

...

<AgGridReact
   columnDefs={columnDefs} // Column Defs for Columns
   defaultColDef={defaultColDef} // Default Column Properties
   ...
/>

Accessing the Grid's API

const gridRef = useRef(); // Optional - for accessing Grid's API
// Example using Grid's API
const buttonListener = useCallback( e => {
   gridRef.current.api.deselectAll();
}, []);

<AgGridReact
   ref={gridRef} // Ref for accessing Grid's API
   />

Consuming Grid Events

Listen to Grid Events by adding a callback to the appropriate on[eventName] property. This example demonstrates consuming the cellClicked event.

<AgGridReact
   onCellClicked={cellClickedListener} // Optional - registering for Grid Event
   ...
/>

Grid Properties

Set other Grid Options by adding parameters to <AgGridReact/> component. This example demonstrates setting animateRows and rowSelection.

<AgGridReact
   animateRows={true} // Optional - set to 'true' to have rows animate when sorted
   rowSelection='multiple' // Options - allows click selection of rows
   ...
/>


Getting Started with AG Grid Enterprise

We would love for you to try out AG Grid Enterprise. There is no cost to trial. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.

The following steps continues from above and installs AG Grid Enterprise.


Install Dependency

In addition to ag-grid-community and ag-grid-react, AG Grid Enterprise also needs ag-grid-enterprise.

npm install --save ag-grid-enterprise

The package.json should now contain the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-enterprise": "29.3.5",
   "ag-grid-react": "29.3.5",
   ...

ag-grid-enterprise contains the Enterprise features only, it does not contain the core grid, hence you still need ag-grid-community and ag-grid-react. Versions of all three must match.


Import Enterprise

Import AG Grid Enterprise intro your application as follows:

import 'ag-grid-enterprise';

And that is all, you use the same <AgGridReact/> component, except this time it comes installed with all the Enterprise features.

For example, you can now Row Group (an Enterprise Feature) by a particular Column by setting rowGroup=true on the Column Definition.

// Each Column Definition results in one Column.
const [columnDefs, setColumnDefs] = useState([
   {field: 'make', rowGroup: true},
   {field: 'model'},
   {field: 'price'}
]);

Results:
Loading...

Angular Data GridGet Started with AG Grid

Quick Look Code Example
import { Component } from '@angular/core';
import { ColDef } from 'ag-grid-community';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: [ './app.component.scss' ]
})
export class AppComponent  {

    columnDefs: ColDef[] = [
        { field: 'make' },
        { field: 'model' },
        { field: 'price' }
    ];

    rowData = [
        { make: 'Toyota', model: 'Celica', price: 35000 },
        { make: 'Ford', model: 'Mondeo', price: 32000 },
        { make: 'Porsche', model: 'Boxster', price: 72000 }
    ];

}
<ag-grid-angular
    style="width: 500px; height: 350px;"
    class="ag-theme-alpine"
    [rowData]="rowData"
    [columnDefs]="columnDefs">
</ag-grid-angular>
@import 'ag-grid-community/styles/ag-grid.css';
@import 'ag-grid-community/styles/ag-theme-alpine.css';

Please refer to our Compatibility Guide for Supported Versions of Angular & AG Grid.

Getting Started with Community Video

In this video we detail the steps to get an application working with Angular and AG Grid Community. We show how to set up Rows and Columns, set some Grid Properties, use the Grid's API and listen to Grid events.



Getting Started with Enterprise Video

The video then follows showing how to get started with AG Grid Enterprise. Please take a look at Enterprise, you don't need a license to trial AG Grid Enterprise, you only need to get in touch if you decide to use it in your project.




Getting Started with AG Grid Community

Below we provide code for a simple AG Grid Angular application. To get this working locally, create a new Angular application as follows:

ng new my-app --style scss --routing false
cd my-app
npm install --save ag-grid-community
npm install --save ag-grid-angular
npm run start

If everything goes well, npm run start has started the web server and conveniently opened a browser pointing to localhost:4200.


Grid Dependencies

Note the package.json has the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-angular": "29.3.5",
   ...

ag-grid-community is the core logic of the Grid, and ag-grid-angular is the Angular Rendering Engine. Both are needed for the grid to work with Angular and their versions must match.


Copy in Application Code

Copy the content below into the file app.modules.ts:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { HttpClientModule } from '@angular/common/http'
import { AgGridModule } from 'ag-grid-angular';
import { AppComponent } from './app.component';

@NgModule({
 declarations: [
   AppComponent
 ],
 imports: [
   BrowserModule,
   HttpClientModule,
   AgGridModule
 ],
 providers: [],
 bootstrap: [AppComponent]
})
export class AppModule { }

Copy the content below into the file app.component.ts:

import { HttpClient } from '@angular/common/http';
import { Component, ViewChild } from '@angular/core';
import { AgGridAngular } from 'ag-grid-angular';
import { CellClickedEvent, ColDef, GridReadyEvent } from 'ag-grid-community';
import { Observable } from 'rxjs';

@Component({
 selector: 'app-root',
 templateUrl: './app.component.html',
 styleUrls: ['./app.component.scss']
})
export class AppComponent {

 // Each Column Definition results in one Column.
 public columnDefs: ColDef[] = [
   { field: 'make'},
   { field: 'model'},
   { field: 'price' }
 ];

 // DefaultColDef sets props common to all Columns
 public defaultColDef: ColDef = {
   sortable: true,
   filter: true,
 };
 
 // Data that gets displayed in the grid
 public rowData$!: Observable<any[]>;

 // For accessing the Grid's API
 @ViewChild(AgGridAngular) agGrid!: AgGridAngular;

 constructor(private http: HttpClient) {}

 // Example load data from server
 onGridReady(params: GridReadyEvent) {
   this.rowData$ = this.http
     .get<any[]>('https://www.ag-grid.com/example-assets/row-data.json');
 }

 // Example of consuming Grid Event
 onCellClicked( e: CellClickedEvent): void {
   console.log('cellClicked', e);
 }

 // Example using Grid's API
 clearSelection(): void {
   this.agGrid.api.deselectAll();
 }
}

Copy the content below into the file app.component.html:

<!-- Button to clear selection -->
<button (click)="clearSelection()">Clear Selection</button>
<!-- AG Grid Angular Component -->
<ag-grid-angular
   style="width: 100%; height: 100%"
   class="ag-theme-alpine"
   [columnDefs]="columnDefs"
   [defaultColDef]="defaultColDef"
   [rowData]="rowData$ | async"
   [rowSelection]="'multiple'"
   [animateRows]="true"
   (gridReady)="onGridReady($event)"
   (cellClicked)="onCellClicked($event)"
 ></ag-grid-angular>

Copy the content below into the file styles.scss:

@import 'ag-grid-community/styles/ag-grid.css';
@import 'ag-grid-community/styles/ag-theme-alpine.css';

html, body {
   height: 100%;
   width: 100%;
   padding: 5px;
   box-sizing: border-box;
   -webkit-overflow-scrolling: touch;
}
If everything is correct, you should see a simple grid that looks like this:

AG Grid in its simplest form

We will now break this file down and explain the different parts...


Grid Module

The AG Grid Module was included inside the app.

import { AgGridModule } from 'ag-grid-angular';

...

 imports: [
   BrowserModule,
   HttpClientModule,
   AgGridModule
 ],

This allows access to the AG Grid component throughout the application.

Grid CSS and Themes

Two CSS files were loaded as follows:

@import 'ag-grid-community/styles/ag-grid.css'; // Core grid CSS, always needed
@import 'ag-grid-community/styles/ag-theme-alpine.css'; // Optional theme CSS

The first ag-grid.css is always needed. It's the core structural CSS needed by the grid. Without this, the Grid will not work.

The second ag-theme-alpine.css is the chosen Grid Theme. This is then subsequently applied to the grid by applying the Theme's CSS Class to the grid element class="ag-theme-alpine".

You can select from any of the Grid Provided Themes. If you don't like the provided themes you can Customise the Provided Theme or do not use a Theme and style the grid yourself from scratch.

The dimension of the Grid is also set on the parent DIV via style={{width: 500, height: 500}}. The grid will fill 100% in both directions, so size it's parent element to the required dimensions.

<ag-grid-angular
   style="width: 100%; height: 100%"
   class="ag-theme-alpine"/>

Setting Row Data

The Grid is provided Row Data via the rowData Grid Property. This is wired up using an Observable.

// Data that gets displayed in the grid
public rowData$!: Observable<any[]>;
...

// Example load data from server
onGridReady(params: GridReadyEvent) {
  this.rowData$ = this.http
    .get<any[]>('https://www.ag-grid.com/example-assets/row-data.json');
}

...

<ag-grid-angular
   [rowData]="rowData$ | async"
   ...

Setting Column Definitions

Columns are defined by setting Column definitions. Each Column Definition defines one Column. Properties can be set for all Columns using the Default Column Definition.

// Each Column Definition results in one Column.
public columnDefs: ColDef[] = [
  { field: 'make'},
  { field: 'model'},
  { field: 'price' }
];

// DefaultColDef sets props common to all Columns
public defaultColDef: ColDef = {
  sortable: true,
  filter: true,
};

...

<ag-grid-angular
   [columnDefs]="columnDefs"
   [defaultColDef]="defaultColDef"
   ...
/>

Accessing the Grid's API

// For accessing the Grid's API
@ViewChild(AgGridAngular) agGrid!: AgGridAngular;
...
// Example using Grid's API
clearSelection(): void {
  this.agGrid.api.deselectAll();
}

Consuming Grid Events

Listen to Grid Events by adding a callback to the appropriate (eventName) output property. This example demonstrates consuming the cellClicked event.

<ag-grid-angular
   (cellClicked)="onCellClicked($event)"
   ...
/>

Grid Properties

Set other Grid Options by adding parameters to <ag-grid-angular/> component. This example demonstrates setting animateRows and rowSelection.

<ag-grid-angular
   [rowSelection]="'multiple'"
   [animateRows]="true"
   ...
/>


Getting Started with AG Grid Enterprise

We would love for you to try out AG Grid Enterprise. There is no cost to trial. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.

The following steps continues from above and installs AG Grid Enterprise.


Install Dependency

In addition to ag-grid-community and ag-grid-angular, AG Grid Enterprise also needs ag-grid-enterprise.

npm install --save ag-grid-enterprise

The package.json should now contain the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-enterprise": "29.3.5",
   "ag-grid-angular": "29.3.5",
   ...

ag-grid-enterprise contains the Enterprise features only, it does not contain the core grid, hence you still need ag-grid-community and ag-grid-angular. Versions of all three must match.


Import Enterprise

Import AG Grid Enterprise intro your application as follows:

import 'ag-grid-enterprise';

And that is all, you use the same <ag-grid-angular/> component, except this time it comes installed with all the Enterprise features.

For example, you can now Row Group (an Enterprise Feature) by a particular Column by setting rowGroup=true on the Column Definition.

// Each Column Definition results in one Column.
public columnDefs: ColDef[] = [
  { field: 'make', rowGroup: true},
  { field: 'model'},
  { field: 'price' }
];

Results:
Loading...

Vue Data GridGet Started with AG Grid

Quick Look Code Example
<template>
  <ag-grid-vue
    style="width: 500px; height: 200px"
    class="ag-theme-alpine"
    :columnDefs="columnDefs"
    :rowData="rowData"
  >
  </ag-grid-vue>
</template>

<script>
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-alpine.css";
import { AgGridVue } from "ag-grid-vue3";

export default {
  name: "App",
  components: {
    AgGridVue,
  },
  setup() {
    return {
      columnDefs: [
        { headerName: "Make", field: "make" },
        { headerName: "Model", field: "model" },
        { headerName: "Price", field: "price" },
      ],
      rowData: [
        { make: "Toyota", model: "Celica", price: 35000 },
        { make: "Ford", model: "Mondeo", price: 32000 },
        { make: "Porsche", model: "Boxster", price: 72000 },
      ],
    };
  }, };</script>
import { createApp } from "vue";
import App from "./App.vue";

createApp(App).mount("#app");

Getting Started with Community Video

In this video we detail the steps to get an application working with Vue and AG Grid Community. We show how to set up Rows and Columns, set some Grid Properties, use the Grid's API and listen to Grid events.



Getting Started with Enterprise Video

The video then follows showing how to get started with AG Grid Enterprise. Please take a look at Enterprise, you don't need a license to trial AG Grid Enterprise, you only need to get in touch if you decide to use it in your project.




Vue 2 vs Vue 3

There are two versions of Vue support, one for Vue 2 and one for Vue 3. The only difference in use is how you import the dependency:

VersionPackage ImportModule Import
Vue 2ag-grid-vue@ag-grid-community/vue
Vue 3ag-grid-vue3@ag-grid-community/vue3

If you are unsure between Package Import and Module Import, you should use the Package Import (i.e. ag-grid-vue/ ag-grid-vue3). For more information on import types please refer to the documentation here.

This tutorial covers the use of Vue 3 with AG Grid - for the Vue 2 version of this tutorial please see the documentaiton here.


Getting Started with AG Grid Community

Below we provide code for a simple AG Grid Vue application. To get this working locally, create a new Vue application as follows (when prompted select Vue 3):

npx -p @vue/cli vue create this-place
cd this-place
npm install --save ag-grid-community
npm install --save ag-grid-vue3
npm run serve

If everything went well npm run serve started the web server and conveniently opened a browser pointing to localhost:8080 (if the browser wasn't automatically launched simply navigate to localhost:8080 in your browser of choice.

Grid Dependencies

Note the package.json has the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-vue3": "29.3.5",
   ...

ag-grid-community is the core logic of the Grid, and ag-grid-vue3 is the Vue Rendering Engine. Both are needed for the grid to work with Vue and their versions must match.

Copy in Application Code

Copy the content below into the file src/App.vue:

<template>
 <button @click="deselectRows">deselect rows</button>
 <ag-grid-vue
   class="ag-theme-alpine"
   style="height: 500px"
   :columnDefs="columnDefs.value"
   :rowData="rowData.value"
   :defaultColDef="defaultColDef"
   rowSelection="multiple"
   animateRows="true"
   @cell-clicked="cellWasClicked"
   @grid-ready="onGridReady"
 >
 </ag-grid-vue>
</template>

<script>
import { AgGridVue } from "ag-grid-vue3";  // the AG Grid Vue Component
import { reactive, onMounted, ref } from "vue";

import "ag-grid-community/styles/ag-grid.css"; // Core grid CSS, always needed
import "ag-grid-community/styles/ag-theme-alpine.css"; // Optional theme CSS

export default {
 name: "App",
 components: {
   AgGridVue,
 },
 setup() {
   const gridApi = ref(null); // Optional - for accessing Grid's API

   // Obtain API from grid's onGridReady event
   const onGridReady = (params) => {
     gridApi.value = params.api;
   };

   const rowData = reactive({}); // Set rowData to Array of Objects, one Object per Row

   // Each Column Definition results in one Column.
   const columnDefs = reactive({
     value: [
          { field: "make" },
          { field: "model" },
          { field: "price" }
     ],
   });

   // DefaultColDef sets props common to all Columns
   const defaultColDef = {
     sortable: true,
     filter: true,
     flex: 1
   };

   // Example load data from server
   onMounted(() => {
     fetch("https://www.ag-grid.com/example-assets/row-data.json")
       .then((result) => result.json())
       .then((remoteRowData) => (rowData.value = remoteRowData));
   });

   return {
     onGridReady,
     columnDefs,
     rowData,
     defaultColDef,
     cellWasClicked: (event) => { // Example of consuming Grid Event
       console.log("cell was clicked", event);
     },
     deselectRows: () =>{
       gridApi.value.deselectAll()
     }
   };
 },
};
</script>

<style lang="scss"></style>
If everything is correct, you should see a simple grid that looks like this:

AG Grid in its simplest form

We will now break this file down and explain the different parts...


Grid CSS and Themes

Two CSS files were loaded as follows:

import 'ag-grid-community/styles/ag-grid.css'; // Core grid CSS, always needed
import 'ag-grid-community/styles/ag-theme-alpine.css'; // Optional theme CSS

The first ag-grid.css is always needed. It's the core structural CSS needed by the grid. Without this, the Grid will not work.

The second ag-theme-alpine.css is the chosen Grid Theme. This is then subsequently applied to the Grid by including the Theme's CSS Class in the Grid's element class="ag-theme-alpine".

<ag-grid-vue
   class="ag-theme-alpine"

You can select from any of the Grid Provided Themes. If you don't like the provided themes you can Customise the Provided Theme or do not use a Theme and style the grid yourself from scratch.

The dimension of the Grid is also set on the grid's element style="height: 500px".


Setting Row Data

The Grid is provided Row Data via the rowData Grid Property. This is wired up using reactive so that it can be updated to data loaded from the server.

 <ag-grid-vue
   :rowData="rowData.value"
...

const rowData = reactive({});

...

// Example load data from server
onMounted(() => {
  fetch("https://www.ag-grid.com/example-assets/row-data.json")
    .then((result) => result.json())
    .then((remoteRowData) => (rowData.value = remoteRowData));
});

Setting Column Definitions

Columns are defined by setting Column definitions. Each Column Definition defines one Column. Properties can be set for all Columns using the Default Column Definition.

 <ag-grid-vue
   :columnDefs="columnDefs.value"
   :defaultColDef="defaultColDef"

...

// Each Column Definition results in one Column.
const columnDefs = reactive({
  value: [{ field: "make" }, { field: "model" }, { field: "price" }],
});


// DefaultColDef sets props common to all Columns
const defaultColDef = {
  sortable: true,
  filter: true,
  flex: 1
};

Accessing the Grid's API

The grid's API is provided in the `onGridReady event. Save a reference to it and then use it later.

const gridApi = ref(null); // Optional - for accessing Grid's API
...

// Obtain API from grid's onGridReady event
const onGridReady = (params) => {
  gridApi.value = params.api;
};
...

// Example using Grid's API
deselectRows: () =>{
  gridApi.value.deselectAll()
}

Consuming Grid Events

Listen to Grid Events by adding a callback to the appropriate @[event-name] property. This example demonstrates consuming the Cell Clicked event via the @cell-clicked property.

 <ag-grid-vue
   @cell-clicked="cellWasClicked"

Grid Properties

Set other Grid Options by adding parameters to <ag-grid-vue/> component. This example demonstrates setting animateRows and rowSelection.

 <ag-grid-vue
   rowSelection="multiple"
   animateRows="true"
   ...
/>


Getting Started with AG Grid Enterprise

We would love for you to try out AG Grid Enterprise. There is no cost to trial. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.

The following steps continues from above and installs AG Grid Enterprise.


Install Dependency

In addition to ag-grid-community and ag-grid-vue3, AG Grid Enterprise also needs ag-grid-enterprise.

npm install --save ag-grid-enterprise

The package.json should now contain the following dependencies:

"dependencies": {
   "ag-grid-community": "29.3.5",
   "ag-grid-enterprise": "29.3.5",
   "ag-grid-vue3": "29.3.5",
   ...

ag-grid-enterprise contains the Enterprise features only, it does not contain the core grid, hence you still need ag-grid-community and ag-grid-vue3. Versions of all three must match.


Import Enterprise

Import AG Grid Enterprise intro your application as follows:

import 'ag-grid-enterprise';

And that is all, you use the same <ag-grid-vue/> component, except this time it comes installed with all the Enterprise features.

For example, you can now Row Group (an Enterprise Feature) by a particular Column by setting rowGroup=true on the Column Definition.

// Each Column Definition results in one Column.
const columnDefs = reactive({
  value: [
       { field: "make", rowGroup: true }, 
       { field: "model" }, 
       { field: "price" }
  ]});